/*
 * Ǝ@vO
 * Copyright (C) 2007 ~V Ўu
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * ̃vO̓t[\tgEFAłBȂ͂At[\tgEF
 * AcɂĔsꂽ GNU ʌOp_񏑃o[W2̒߂
 * ̉ōĔЕz܂͉ς邱Ƃł܂B
 * 
 * ̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ* 
 * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ̂
 * ߑS݂܂BڂGNU ʌOp_񏑂B
 * 
 * Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕ꕔ
 * 󂯎͂łB󂯎ĂȂ΁At[\tgEFAc
 * ŐĂ( the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA)B
 */
package ume.puzzle.sudoku;

import java.io.File;
import java.io.PrintStream;

import javax.swing.JFileChooser;
import javax.swing.JScrollPane;
import javax.swing.UIManager;

import ume.puzzle.sudoku.algorithm.Solver;
import ume.puzzle.sudoku.context.Context;
import ume.puzzle.sudoku.problem.Problem;
import ume.puzzle.sudoku.view.Frame;
import ume.puzzle.sudoku.view.View;

public class Main {
	public static PrintStream out;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

			String filename = "";
			String basename = "";

			if (args.length >= 1) {
				filename = args[0];
				basename = new File(filename).getName();
			} else {
				JFileChooser chooser = new JFileChooser();
				int ret = chooser.showOpenDialog(null);
				if (ret != JFileChooser.APPROVE_OPTION)
					return;
				filename = chooser.getSelectedFile().getCanonicalPath();
				basename = chooser.getSelectedFile().getName();
			}
			Problem problem = new Problem(filename);

			out = System.out;

			Context context = new Context(problem);
			View view = new View(context);
			Frame frame = new Frame(basename);
			JScrollPane scroll = new JScrollPane(view);
			frame.setContentPane(scroll);
			frame.pack();
			frame.setVisible(true);
			Solver solver = new Solver(context);
			new Thread(solver).start();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
