/*
 * Ǝ@vO
 * Copyright (C) 2007 ~V Ўu
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * ̃vO̓t[\tgEFAłBȂ͂At[\tgEF
 * AcɂĔsꂽ GNU ʌOp_񏑃o[W2̒߂
 * ̉ōĔЕz܂͉ς邱Ƃł܂B
 * 
 * ̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ* 
 * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ̂
 * ߑS݂܂BڂGNU ʌOp_񏑂B
 * 
 * Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕ꕔ
 * 󂯎͂łB󂯎ĂȂ΁At[\tgEFAc
 * ŐĂ( the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA)B
 */
package ume.puzzle.sudoku.algorithm;

import ume.puzzle.sudoku.context.Box;
import ume.puzzle.sudoku.context.BoxGroup;
import ume.puzzle.sudoku.context.Context;

public class Solver implements Runnable {
	private final Context context;

	public Solver(Context context) {
		this.context = context;
	}

	public void run() {
		try {
			while (true) {
				boolean modified = false;

				for (int x = 0; x < context.getWidth(); x++) {
					for (int y = 0; y < context.getHeight(); y++) {
						Box box = context.getBox(x, y);
						if (box.isDirty()) {
							if (box.isNumberFixed()) {
								for (BoxGroup group : box.getAssociatedGroups()) {
									for (Box buddy : group) {
										if (buddy != box) {
											modified |= buddy.clearBitmap(box.getBitmap());
										}
									}
								}
							}
							box.setDirty(false);
						}
					}
				}

				for (BoxGroup group : context.getGroups()) {
					loop: for (int num = 1; num <= 9; num++) {
						Box found = null;
						int bitmap = Box.getBitmapFromNumber(num);
						for (Box box : group) {
							if ((box.getBitmap() & bitmap) != 0) {
								if (found == null) {
									found = box;
								} else {
									continue loop;
								}
							}
						}
						if (found != null) {
							modified |= found.andBitmap(bitmap);
						}
					}
				}
				if (!modified) {
					break;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
