/*
 * Ǝ@vO
 * Copyright (C) 2007 ~V Ўu
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * ̃vO̓t[\tgEFAłBȂ͂At[\tgEF
 * AcɂĔsꂽ GNU ʌOp_񏑃o[W2̒߂
 * ̉ōĔЕz܂͉ς邱Ƃł܂B
 * 
 * ̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ* 
 * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ̂
 * ߑS݂܂BڂGNU ʌOp_񏑂B
 * 
 * Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕ꕔ
 * 󂯎͂łB󂯎ĂȂ΁At[\tgEFAc
 * ŐĂ( the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA)B
 */
package ume.puzzle.sudoku.problem;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import ume.puzzle.exception.BadProblemException;

public class Problem {
	private final int[][] number;
	private final int maxNumber;
	private final int blockWidth;
	private final int blockHeight;

	public Problem(String filename) throws BadProblemException, IOException {
		FileInputStream fis = new FileInputStream(filename);
		BufferedReader reader = new BufferedReader(new InputStreamReader(fis));

		try {
			// ŏɔՖʂ̌` parse 
			{
				String str = reader.readLine();
				String[] tokens = str.split(",");
				if (tokens.length != 3) {
					throw new BadProblemException();
				}
				maxNumber = Integer.parseInt(tokens[0].trim());
				blockWidth = Integer.parseInt(tokens[1].trim());
				blockHeight = Integer.parseInt(tokens[2].trim());
				number = new int[maxNumber][maxNumber];
			}

			for (int y = 0; y < maxNumber; y++) {
				String str = reader.readLine();
				String[] tokens = str.split(",");
				if (tokens.length != maxNumber) {
					throw new BadProblemException();
				}
				for (int x = 0; x < maxNumber; x++) {
					String token = tokens[x].trim();
					if (token.equals("_")) {
						number[y][x] = 0;
					} else {
						number[y][x] = Integer.parseInt(token);
					}
				}
			}
		} finally {
			fis.close();
		}
	}

	public int getMaxNumber() {
		return maxNumber;
	}

	public int getNumber(int x, int y) {
		return number[y][x];
	}
	public int getBlockWidth() {
		return blockWidth;
	}

	public int getBlockHeight() {
		return blockHeight;
	}
}
