/*
 * Ǝ@vO
 * Copyright (C) 2007 ~V Ўu
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * ̃vO̓t[\tgEFAłBȂ͂At[\tgEF
 * AcɂĔsꂽ GNU ʌOp_񏑃o[W2̒߂
 * ̉ōĔЕz܂͉ς邱Ƃł܂B
 * 
 * ̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ* 
 * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ̂
 * ߑS݂܂BڂGNU ʌOp_񏑂B
 * 
 * Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕ꕔ
 * 󂯎͂łB󂯎ĂȂ΁At[\tgEFAc
 * ŐĂ( the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA 02111-1307 USA)B
 */
package ume.puzzle.sudoku.view;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JComponent;

import ume.puzzle.sudoku.context.Box;
import ume.puzzle.sudoku.context.Context;
import ume.puzzle.sudoku.context.ContextListener;

public class View extends JComponent implements ContextListener {
	/**
	 * <code>serialVersionUID</code> ̃Rg
	 */
	private static final long serialVersionUID = 1L;

	private final Context context;

	public static final int DEFAULT_BOX_SIZE = 32;
	private int boxSize;
	private Dimension viewSize;

	public View(Context context) {
		this.context = context;

		setBackground(Color.WHITE);
		context.addContextListener(this);
		setBoxSize(DEFAULT_BOX_SIZE);
	}

	/**
	 * @return boxSize ߂܂B
	 */
	public int getBoxSize() {
		return boxSize;
	}

	/**
	 * @param boxSize
	 *            boxSize ݒB
	 */
	public void setBoxSize(int boxSize) {
		this.boxSize = boxSize;
		viewSize = new Dimension(boxSize * context.getWidth(), boxSize
				* context.getHeight());
		setPreferredSize(viewSize);
		setMaximumSize(viewSize);
		if (isVisible()) {
			repaint();
		}
	}

	protected void paintComponent(Graphics g) {
		Graphics myg = g.create();
		myg.setFont(new Font(Font.SANS_SERIF, Font.PLAIN, boxSize));
		Rectangle rect = g.getClipBounds();
		int left, right, top, bottom;

		left = Math.max(0, rect.x / boxSize);
		right = Math.min(context.getWidth(),
				(rect.x + rect.width + boxSize - 1) / boxSize);
		top = Math.max(0, rect.y / boxSize);
		bottom = Math.min(context.getHeight(),
				(rect.y + rect.height + boxSize - 1) / boxSize);

		for (int y = top; y < bottom; y++) {
			for (int x = left; x < right; x++) {
				Box box = context.getBox(x,y);
				if (box.isNumberFixed()) {
					myg.setColor(Color.WHITE);
					myg.fillRect(boxSize * x, boxSize * y, boxSize, boxSize);
					myg.setColor(Color.BLACK);
					myg.drawString(String.format("%d", context.getBox(x, y).getNumber()), boxSize * x, boxSize * (y + 1));
				} else {
					myg.setColor(Color.WHITE);
					myg.fillRect(boxSize * x, boxSize * y, boxSize, boxSize);
				}
			}
		}
	}

	public void completed(Context context) {
		// TODO Auto-generated method stub
		
	}

	public void valueChanged(Context context, int x, int y) {
		// TODO Auto-generated method stub
		
	}

	public void valueFixed(Context context, int x, int y) {
		repaint();
	}
}
